/*
*   _______     _      _  __          __
*  | _____/    | |    | | \ \   __   / /
*  | |         | |    | |  | | /  \ | |
*  | |         | |____| |  | |/ __ \| |
*  | |   ___   | ______ |  |   /  \   |
*  | |  |_  |  | |    | |  |  /    \  |
*  | |    | |  | |    | |  | |      | |
*  | |____| |  | |    | |  | |      | |
*  |_______/   |_|    |_|  \_/      \_/
*
*
*
*  Last Edited: 12-30-07
*
*  ============
*   Changelog:
*  ============
*
*  v3.0
*    -Added ML
*    -Optimized Code
*
*  v2.0
*    -Rewrote Code
*
*  v1.0
*    -Initial Release
*
*/

#define VERSION	"3.0"

#include <amxmodx>
#include <amxmisc>
#include <fun>

new bool:cs

new show_activity_pcvar

public plugin_init()
{
	register_plugin("GHW Revive",VERSION,"GHW_Chronic")

	register_clcmd("amx_revive","admin_revive",ADMIN_LEVEL_G,"<nick | @all (if CS/CZ: @CT | @T)> [health]")

	show_activity_pcvar = get_cvar_pointer("amx_show_activity")

	new modname[32]
	get_modname(modname,31)

	if(containi(modname,"cstrike")!=-1 || containi(modname,"czero")!=-1) cs=true

	register_dictionary("GHW_Revive.txt")
}

public admin_revive(id,level,cid)
{
	if(!cmd_access(id,level,cid,2))
	{
		return PLUGIN_HANDLED
	}

	new arg1[32]
	read_argv(1,arg1,31)
	new arg2[32]
	read_argv(2,arg2,31)

	new health = str_to_num(arg2)

	if(health<=0)
		health = 100

	new param[1]
	param[0] = health

	new cvar_value = get_pcvar_num(show_activity_pcvar)

	if(cs)
	{
		if(equal(arg1,"@CT"))
		{
			if(cvar_value==1)
			{
				client_print(0,print_chat,"",0,"MSG_REVIVE_CT1")
			}
			else if(cvar_value>1)
			{
				new aName[32]
				get_user_name(id,aName,31)
				client_print(0,print_chat,"",0,"MSG_REVIVE_CT2",aName)
			}

			new players[32], num
			get_players(players,num,"egh","CT")
			for(new i=0;i<num;i++)
			{
				revive(players[i])
				set_task(0.5,"revive2",players[i],param,1)
			}
		}
		else if(equal(arg1,"@T"))
		{

			if(cvar_value==1)
			{
				client_print(0,print_chat,"",0,"MSG_REVIVE_T1")
			}
			else if(cvar_value>1)
			{
				new aName[32]
				get_user_name(id,aName,31)
				client_print(0,print_chat,"",0,"MSG_REVIVE_T2",aName)
			}

			new players[32], num
			get_players(players,num,"egh","Terrorist")
			for(new i=0;i<num;i++)
			{
				revive(players[i])
				set_task(0.2,"revive",players[i])
				set_task(0.4,"revive2",players[i],param,1)
			}
		}
	}
	else if(equal(arg1,"@all"))
	{
		if(cvar_value==1)
		{
			client_print(0,print_chat,"",0,"MSG_REVIVE_ALL1")
		}
		else if(cvar_value>1)
		{
			new aName[32]
			get_user_name(id,aName,31)
			client_print(0,print_chat,"",0,"MSG_REVIVE_ALL2",aName)
		}

		new players[32], num
		get_players(players,num,"gh")
		for(new i=0;i<num;i++)
		{
			revive(players[i])
			set_task(0.2,"revive",players[i])
			set_task(0.4,"revive2",players[i],param,1)
		}
	}
	else
	{
		new target = cmd_target(id,arg1,3)
		if(!target)
		{
			return PLUGIN_HANDLED
		}

		new name[32]
		get_user_name(target,name,31)

		if(cvar_value>0)
		{
			new pName[32]
			get_user_name(target,pName,31)

			if(cvar_value==1)
			{
				client_print(0,print_chat,"",0,"MSG_REVIVE_NAME1",pName)
			}
			else
			{
				new aName[32]
				get_user_name(id,aName,31)
				client_print(0,print_chat,"",0,"MSG_REVIVE_NAME2",aName,pName)
			}
		}

		console_print(id,"",name)

		revive(target)

		set_task(0.2,"revive",target)
		set_task(0.4,"revive2",target,param,1)
	}
	return PLUGIN_HANDLED
}

public revive(id)
{
	spawn(id)
}

public revive2(param[1],id)
{
	spawn(id)
	if(cs)
	{
		give_item(id,"weapon_knife")
		if(get_user_team(id)==1)
		{
			give_item(id,"weapon_glock18")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
		}
		else
		{
			give_item(id,"weapon_glock18")
			give_item(id,"ammo_9mm")
			give_item(id,"ammo_9mm")
		}
	}
	set_user_health(id,param[0])
}
